#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2099 宝塔软件(http://bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: sudem mail@szhcloud.cn
# +-------------------------------------------------------------------

#+--------------------------------------------------------------------
#|  百度网盘插件
#|  1.01更新日志
#|  优化了安装脚本中对pyOpenSSL 重新安装的问题
#|  修复一处bug(当百度网盘访问的路径中带 + 的文件编码问题 )
#|
#+--------------------------------------------------------------------
import sys,os,json,base64,re,time
import psutil,requests

#设置运行目录
os.chdir("/www/server/panel")

#添加包引用位置并引用公共包
sys.path.append("class/")
sys.path.append("plugin/baidupan")
import public, db, time
import panelBackup
import BDpan



#取通用对象
class dict_obj:
    def __contains__(self, key):
        return getattr(self,key,None)
    def __setitem__(self, key, value): setattr(self,key,value)
    def __getitem__(self, key): return getattr(self,key,None)
    def __delitem__(self,key): delattr(self,key)
    def __delattr__(self, key): delattr(self,key)
    def get_items(self): return self

# 取得系统信息
class   system_info:
    def GetSystemVersion(self):
        # 取操作系统版本
        version = public.readFile('/etc/redhat-release')
        if not version:
            version = public.readFile('/etc/issue').strip().split("\n")[0].replace('\\n', '').replace('\l','').strip();
        else:
            version = version.replace('release ', '').strip();
        return version

    def GetCPUModel(self):
        # 取得CPU的型号
        model = os.popen("cat /proc/cpuinfo | grep 'model name' |uniq").readlines()[0]
        model = model.split(":")[1].strip()
        return model

    def GetCPUNum(self):
        num = psutil.cpu_count()
        return str(num)



class baidupan_main:
    __plugin_path = "/www/server/panel/plugin/baidupan/"
    __config = None
    __python = ""
    BD = BDpan.BDpan()

    #构造方法
    def  __init__(self):
        if os.path.exists("/www/server/panel/pyenv/bin/python"):
            self.__python = "/www/server/panel/pyenv/bin/python"
        else:
            self.__python = "python"
        if not os.path.exists(self.__plugin_path + "conf/backup/"):
            os.mkdir(self.__plugin_path+"conf/")
            os.mkdir(self.__plugin_path + "conf/backup")
        if not os.path.exists(self.__plugin_path+"DownLoad"):
            os.mkdir(self.__plugin_path+"DownLoad")
        # 如果插件没有授权
        if not os.path.exists(self.__plugin_path+"auth.json"):
            self.PluginInit("")
        else:
            # 如果插件的版本发生了变化,更新授权
            auth = json.loads(public.ReadFile(self.__plugin_path + 'auth.json'))
            info = json.loads(public.ReadFile(self.__plugin_path + 'info.json'))
            if "Plugin_Ver" in auth and info['versions'] != auth['Plugin_Ver']:
                self.Auth_Update()
            # 如果面板的版本发生了变换,更新授权
            if "BT_Ver" in auth and public.version() != auth['BT_Ver']:
                self.Auth_Update()



    # 插件初始化
    def PluginInit(self,args):
        self.Auth_Reg()
        auth = json.loads(public.ReadFile(self.__plugin_path+"auth.json"))
        return {"status":"Success","auth":auth}

    # 加载静态页面文件
    def LoadPages(self,args):
        page = args.page
        if os.path.exists(self.__plugin_path + "/static/html/" + page + ".html"):
            page = public.ReadFile(self.__plugin_path + "/static/html/" + page + ".html")
        else:
            page = "ERROR,404 NOT FOUND"
        return {"status":"success","page":page}

    # 获取当前百度云登录状态
    def GetAccountState(self,args):
        auth = dict_obj()
        auth.callback = "http://" + public.GetHost() + ":" + public.GetHost(True)
        aconfig = json.loads(public.ReadFile(self.__plugin_path + "auth.json"))
        auth.usertoken = aconfig["UserToken"]
        auth.authparam = public.GetRandomString(16)
        auth.authtoken = public.md5(auth.usertoken + aconfig["UserKey"] + auth.authparam)
        authurl = self.BD.BaiDuAuth(auth)
        if os.path.exists(self.__plugin_path+"baidu.json"):
            return {"status":"Success","state":"login","span":"<a href=\""+authurl+"\" target=\"_blank\" style=\"color:green\">已登录(点击切换账号)</a>"}
        else :
            return {"status":"Success","state":"unlogin","span":"<a href=\""+authurl+"\" target=\"_blank\" style=\"color:red\">未登录(点击这里登录)</a>"}


    # 获得绑定用户的用户名和头像信息
    def GetAccountInfo(self,args):
        User= json.loads(self.BD.Get_UserData())
        info  = {"username":User['baidu_name'],"logo":User['avatar_url'],"utype":User['vip_type'],"Ukey":User['uk']}
        return {"status":"Success","info":info}

    # 获得绑定用户的磁盘大小信息
    def GetAccountDisk(self,args):
        Disk = json.loads(self.BD.Get_UserDisk())
        per = round( Disk['used']/Disk['total']*100, 3)
        if per == 0: per = "0.01"
        total = public.to_size( Disk['total'])
        used = public.to_size( Disk['used'])
        return {"status":"Success","total":total,"used":used,"per":per}

    # 获得网盘指定路径下的文件列表
    def GetDiskPathDir(self,args):
        dir=json.loads(self.BD.Get_PathDir(args))
        if dir['errno'] == -9:
            return {"status":"Failed","msg":"获取文件列表失败,目录 ["+args.path+"]不存在!"}
        elif dir['errno'] == -7:
            return {"status":"Failed", "msg": "获取文件列表失败,目录 [" + args.path + "]文件或目录名错误或无权访问!"}
        else:
            num = len(dir['list'])
            id = 0
            while( id != num):
                if dir['list'][id]['size']!= 0:
                    dir['list'][id]['size'] = public.to_size(dir['list'][id]['size'])
                id = id + 1
            return {"status":"Success","list":dir['list'],"num":num}


    # 删除百度网盘上指定的文件
    def DiskFileDel(self,args):
        Res=self.BD.FileDel(args.path)
        Del=json.loads(Res)
        if Del["errno"] == 0:
            return {"status":"Success","fname":Del['info'][0]['path']}
        else:
            return {"status":"Failed","msg":Res}

    #复制百度网盘上指定的文件
    def DiskFileCopy(self,args):
        Res=self.BD.FileCopy(args.opath,args.dest,args.fname)
        Copy = json.loads(Res)
        if Copy["errno"] == 0:
            return {"status": "Success", "fname": Copy['info'][0]['path']}
        else:
            return {"status": "Failed", "msg": Res}

    #移动百度网盘上的指定文件
    def DiskFileMove(self,args):
        Res=self.BD.FileMove(args.opath,args.dest,args.fname)
        Move = json.loads(Res)
        if Move["errno"] == 0:
            return {"status": "Success", "fname": Move['info'][0]['path']}
        else:
            return {"status": "Failed", "msg": Res}

    #重命名百度网盘上的指定文件
    def DiskFileRename(self,args):
        Res=self.BD.FileRename(args.fpath,args.fname)
        Rename = json.loads(Res)
        if Rename["errno"] == 0:
            return {"status": "Success", "fname": Rename['info'][0]['path']}
        else:
            return {"status": "Failed", "msg": Res}

    #新建文件夹
    def DiskFilePathNew(self,args):
        Res = self.BD.FilePathAdd(args.path)
        Path = json.loads(Res)
        if Path["errno"] == 0:
            return {"status": "Success", "fname": Path['path']}
        else:
            return {"status": "Failed", "msg": Res}

    # 从前端上传文件
    def DiskFileUploadPath(self,args):
        import panelTask
        if os.path.exists(args.lpath):
            fname = os.path.basename(args.lpath)
            task = panelTask.bt_task()
            task_name = "百度网盘管理器(上传--[" + fname + "])"
            task_type = 0
            task_shell = "cd /www/server/panel/plugin/baidupan/ && "+ self.__python +" BDpan.py -u -m -p \"" + args.lpath + "\" -s \"" + args.spath + "\""
            task.create_task(task_name, task_type, task_shell)
            return {"status": "Success", "task_name": task_name, "shell": task_shell}
        else :
            return {"status":"Failed","msg":"文件["+args.lpath+"] 不存在!"}

    # 使用任务队列下载指定的文件
    def DownLoadFileUseLine(self,args):
        import panelTask
        task = panelTask.bt_task()
        task_name = "百度网盘管理器(下载--["+args.fname+"])"
        task_type = 0
        # 判断文件路径是否合法
        if not self.FileNameStrCheck(args.fpath):
            return {"status":"Failed","msg":"文件名中含有非法字符串!"}
        task_shell = "cd /www/server/panel/plugin/baidupan/ && "+ self.__python +" BDpan.py -d -p \""+args.fpath+"\" -f "+args.fid
        task.create_task(task_name,task_type,task_shell)
        return {"status": "Success", "task_name":task_name,"shell":task_shell}

    # 取文件下载地址
    def DownloadRealAddress(self,args):
        url = self.BD.FileDownload_URL(args.fid)
        return {"status":"Success","fid":args.fid,"url":url}

    # 获取任务队列列表信息
    def PanelTaskList(self,args):
        import panelTask
        task = panelTask.bt_task()
        get = dict_obj()
        get.status = "-3"
        list = task.get_task_lists(get)
        BDTask = []
        num = 0
        tname = tinfo = ""
        for t in list:
            if "百度网盘管理器" in t["name"]:
                BDTask.append(t)
                num = num+1
        if num!= 0 :
            tid = BDTask[0]["id"]
            ttype = BDTask[0]["type"]
            tname = BDTask[0]["name"]
            tinfo = task.get_task_log(tid, ttype, 12)
            tinfo = tinfo.replace('<br>', '\n')
        return {"status":"Success","List":BDTask,"tname":tname,"tinfo":tinfo,"num":num}

    # 获得宝塔面板上的计划任务信息并绑定到自动备份任务
    def BTBackUpListListen(self,args):
        import crontab
        ctab = crontab.crontab()
        ctablist = ctab.GetCrontab("")
        back = []
        for task in ctablist:
            if task["backupTo"] == "baidupan":
                back.append(task)
        return {"status":"Success","num":len(back),"list":back}

   # 获取文件备份时保存的地址
    def GetBackUpSavePath(self,args):
        if os.path.exists(self.__plugin_path + "baidu.json"):
            baidu = public.ReadFile(self.__plugin_path + "baidu.json")
            baidu = json.loads(baidu)
            upload_path = baidu["upload_path"]
        else:
            upload_path =  "/apps/BTBD/backup/"
        return {"status":"success","upload_path":upload_path}

    # 设置文件备份是保存的地址
    def SetBackUpSavePath(self, args):
        if os.path.exists(self.__plugin_path + "baidu.json"):
            baidu = public.ReadFile(self.__plugin_path + "baidu.json")
            baidu = json.loads(baidu)
            baidu["upload_path"] = args.upload
            upload_path = baidu["upload_path"]
            public.WriteFile(self.__plugin_path+"baidu.json",json.dumps(baidu))
        else:
            upload_path = "/apps/BTBD/backup/"
        return {"status": "success", "upload_path": upload_path}



    # 从命令行上传宝塔计划任务备份的文件
    def TaskBackup(self,path,upload):
        import panelTask
        fname = os.path.basename(path)
        task = panelTask.bt_task()
        task_name = "百度网盘管理器(上传--[" + fname + "])"
        task_type = 0
        task_shell = "cd /www/server/panel/plugin/baidupan/ && "+ self.__python +" BDpan.py -u  -p \"" + path + "\" -s \""+upload+fname+"\" "
        task.create_task(task_name, task_type, task_shell)

    # 下载文件夹
    def DownLoadPathUseLine(self,args):
        path  = dict_obj()
        path.path = args.fpath
        import panelTask
        task = panelTask.bt_task()
        task_name = "百度网盘管理器(文件夹下载--[" + args.fname + "])"
        task_type = 0
        # 判断文件路径是否合法
        if not self.FileNameStrCheck(args.fpath):
            return {"status": "Failed", "msg": "文件名中含有非法字符串!"}
        task_shell = "cd /www/server/panel/plugin/baidupan/ && "+ self.__python +" BDpan.py -a -p \"" + args.fpath +"\" -i \""+args.fname+"\""
        task.create_task(task_name, task_type, task_shell)
        return {"status": "Success", "task_name": task_name, "shell": task_shell}


    def AuthCallback(self,args):
        token = args.token
        html = public.ReadFile(self.__plugin_path+"static/html/callback.html");
        return html

    def AuthCallback_Write(self,args):
        bjson = json.loads(args.bjson)
        bjson["upload_path"] = "/apps/BTBD/backup/"
        public.WriteFile(self.__plugin_path + "/baidu.json", json.dumps(bjson))
        return {"status": "Success", "msg":"Write Data Success"}


    # 获取本机IP地址的信息
    # @mode add   取得本地服务器的ip地址（公网）
    # @mode local 取得本地服务器的位置信息（根据公网ip）
    def Getip(self, mode):
        url = "http://v2.api.iw3c.top/?api=ip&ip=0.0.0.0"
        _data = json.loads(public.HttpGet(url, 5))
        data = _data['data']
        if mode == "add":
            return data['ip']
        elif mode == "local":
            return data['local'] + "--" + data['isp']

    # 计算本机的UserToken
    def Get_UserToken(self):
        lines = os.popen("cd " + self.__plugin_path + " && ./BT_Auth -T ").read()
        lines = lines.split("\n")[0].strip()
        return lines

    # 判断输入的文件路径是否符合文件命名规范
    def FileNameStrCheck(self,filepath):
        if not os.path.exists("/FileNameTemp"):os.mkdir("/FileNameTemp")
        file = filepath.split("/")
        num = len(file)
        filename = file[num-1]
        public.WriteFile("/FileNameTemp/"+filename,"FileNameStrCheck")
        if os.path.exists("/FileNameTemp/"+filename):
            os.popen("rm -rf /FileNameTemp")
            return True
        else:
            os.popen("rm -rf /FileNameTemp")
            return False


    # 系统注册 换取 UserToken 票据
    # 请注意 UserToken 票据非常重要 ，这是开启 客户端管理功能 时的加密密钥
    # 如果 服务器的 系统版本和 CPU 型号 以及公网IP地址 发生了变化 UserToken 的值将发生变化
    # TOKENKEY 一串随机字符串 用来辅助加密UserToken
    def Auth_Reg(self):
        osys = system_info()
        System_Version = osys.GetSystemVersion()
        CPU_Model = osys.GetCPUModel()
        CPU_Num = osys.GetCPUNum()
        Mac_Address = public.get_mac_address()
        BT_Version = public.version()
        info = json.loads(public.ReadFile(self.__plugin_path + 'info.json'))
        Plugin_Version = info['versions']
        data = "MAC=" + Mac_Address + "&CPU_Model=" + CPU_Model + "&CPU_Num=" + CPU_Num + "&Sys=" + System_Version + "&BT_Ver=" + BT_Version + "&Plugin_Ver=" + Plugin_Version + "&Type=frps_dev"
        data = base64.b64encode(data.encode()).decode()
        # 执行BT_Auth 进行授权
        os.popen("cd " + self.__plugin_path + " && ./BT_Auth -A " + data)

    # 系统授权授信更新
    # Tips: 当用户机器上安装的插件版本,宝塔面板版本发生改变时，为了确保数据安全，更新授权授信数据
    def Auth_Update(self):
        osys = system_info()
        Mac_Address = public.get_mac_address()
        BT_Version = public.version()
        info = json.loads(public.ReadFile(self.__plugin_path + 'info.json'))
        Plugin_Version = info['versions']
        data = "MAC=" + Mac_Address + "&BT=" + BT_Version + "&Plugin=" + Plugin_Version;
        data = base64.b64encode(data.encode()).decode()
        auth = json.loads(public.ReadFile(self.__plugin_path + 'auth.json'))
        # 执行BT_Auth 进行授权
        os.popen("cd " + self.__plugin_path + " && ./BT_Auth -U " + data + " " + auth['UserKey'])
        self.Plugin_InitStatusChange()

class backupTools(panelBackup.backup):

    _baidu = ""
    _upload = ""
    __plugin_path = "/www/server/panel/plugin/baidupan/"

    def __init__(self):
        self._baidu = baidupan_main()
        buser = public.ReadFile(self.__plugin_path + "baidu.json")
        buser = json.loads(buser)
        self._path = public.M('config').where("id=?", (1,)).getField('backup_path')
        self._upload = buser["upload_path"]

    def backupSite(self, name, count):
        filepath = self.backup_site(name, save=count)
        self._baidu.TaskBackup(filepath,self._upload)


    def backupDatabase(self, name, count):
        filepath = self.backup_database(name, save=count)
        self._baidu.TaskBackup(filepath, self._upload)

    # 备份指定目录
    def backupPath(self, path, count):
        filepath = self.backup_path(path, save=count)
        self._baidu.TaskBackup(filepath, self._upload)

    def backupSiteAll(self, save):
        sites = public.M('sites').field('name').select()
        for site in sites:
            self.backupSite(site['name'],save)

    def backupDatabaseAll(self, save):
        databases = public.M('databases').field('name').select()
        for database in databases:
            self.backupDatabase(database['name'], save=save)

#在非命令行模式下引用面板缓存和session对象
if __name__ != '__main__':
    from BTPanel import cache,session,redirect

else:
    # 设置运行目录

    os.chdir('/www/server/panel')
    sys.path.append("class/")
    if sys.version_info[0] == 2:
        reload(sys)
        sys.setdefaultencoding('utf-8')


    # 添加包引用位置并引用公共包
    sys.path.append("class/")
    sys.path.append("plugin/baidupan")

    backup = backupTools()
    type = sys.argv[1]
    if type == 'site':
        if sys.argv[2] == 'ALL':
            backup.backupSiteAll(sys.argv[3])
        else:
            backup.backupSite(sys.argv[2], sys.argv[3])
    elif type == 'path':
        backup.backupPath(sys.argv[2], sys.argv[3])
    elif type == 'database':
        if sys.argv[2] == 'ALL':
            backup.backupDatabaseAll(sys.argv[3])
        else:
            backup.backupDatabase(sys.argv[2], sys.argv[3])





