#!/bin/bash
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH

#配置插件安装目录
install_path=/www/server/panel/plugin/baidupan

#安装
Install()
{
	
	echo '正在安装...'
	#==================================================================
	echo '安装编译所需要的环境...'
	yum install libcurl gcc gcc-c++ aria2 -y
	sudo apt install build-essential libcurl4-openssl-dev aria2 -y
	rm -rf $install_path/BT_Auth_tmp
	mkdir $install_path/BT_Auth_tmp && cd $install_path/BT_Auth_tmp && wget https://download.szhcloud.cn/btpanel/baidupan/BT_Auth/baidupan_v20200712.zip
	unzip baidupan_v20200712.zip

	echo '编译授权需要的文件'
	g++ BT_Auth.cpp BT_Public.cpp CHttpRequest.cpp  -o BT_Auth -lcurl -lcrypto -w  -std=c++11
	mv BT_Auth $install_path/BT_Auth
	cd $install_path && rm -rf $install_path/BT_Auth_tmp

	#依赖安装开始
  #兼容宝塔 7.3 自带python 环境的新标准
   if [ ! -f "/www/server/panel/pyenv/bin/python" ];then
       pip install pyOpenSSL
       python $install_path/baidupan_install.py
  else
      /www/server/panel/pyenv/bin/pip    install pyOpenSSL
      /www/server/panel/pyenv/bin/python $install_path/baidupan_install.py
  fi
  sudo -i chmod -R 777 /www/server/panel/plugin/baidupan/BT_Auth

	#依赖安装结束
	#==================================================================

	echo '================================================'
	echo '安装完成'
}

#卸载
Uninstall()
{
	rm -rf $install_path
}

#操作判断
if [ "${1}" == 'install' ];then
	Install
elif [ "${1}" == 'uninstall' ];then
	Uninstall
else
	echo 'Error!';
fi

