   /**
     * 发送请求到插件
     * 注意：除非你知道如何自己构造正确访问插件的ajax，否则建议您使用此方法与后端进行通信
     * @param function_name  要访问的方法名，如：get_logs
     * @param args           传到插件方法中的参数 请传入数组，示例：{p:1,rows:10,callback:"demo.get_logs"}
     * @param callback       请传入处理函数，响应内容将传入到第一个参数中(false 时通过layer.msg 回显消息)
     * @param timeout        插件的超时处理时间 默认 3600s
     * @param plugin_name    插件的名称 默认为 bt_cls
     */
    function request_plugin(function_name, args, callback, timeout,plugin_name,layerclose=true) {
        if (!timeout) timeout = 3600;
        if(!plugin_name) plugin_name = "baidupan";
        $.ajax({
            type:'POST',
            url: '/plugin?action=a&s=' + function_name + '&name=' + plugin_name,
            data: args,
            timeout:timeout,
            success: function(rdata) {
                if (!callback) {
                    layer.msg(rdata.msg, { icon: rdata.status ? 1 : 2 });
                    return;
                }
                else if(callback=="rdata") return rdata;
                else return callback(rdata);
            },
            error: function(ex) {
                if (!callback) {
                    layer.msg('请求过程发现错误!', { icon: 2 });
                    return;
                }
                return callback(ex);
            }
        });
    }


    function in_list(list,value)
    {
        var len = list.length;
        for(var p=0;p<len;p++) if(value == list[p]) return true;
        return false
    }



    function input_switch(domid,callback=false)
    {
        var domhtml = "";var domlabel="";
        if (callback) domlabel = '<label class="btswitch-btn" for="input_'+domid+'" onclick="input_switch(\''+domid+'\','+domid+'_callback)"></label>';
        else domlabel =  '<label class="btswitch-btn" for="input_'+domid+'" onclick="input_switch(\''+domid+'\')"></label>';
        if($("#input_"+domid).val()=="off")
           domhtml = ' <input class="btswitch btswitch-ios" id="input_'+domid+'" value="on" type="checkbox" checked="checked">' + domlabel;
        else domhtml = ' <input class="btswitch btswitch-ios" id="input_'+domid+'" value="off" type="checkbox" >' +domlabel;
        $("#"+domid).html(domhtml);
        if(callback)callback($("#input_"+domid).val());
    }



    function randomString(len) {
　　      len = len || 32;
          var chars = 'ABCDEFGHIJKMLNOPQRSTUVWXYZabcdefghijkmlnopqrstuvwxyz0123456789'
　　      var maxPos = chars.length;
　　      var pwd = '';for (i = 0; i < len; i++) pwd +=chars.charAt(Math.floor(Math.random() * maxPos));
　　      return pwd;
   }


   function GetBTPanelFileIco(fileName) {
         var extArr = fileName.split(".");
	     var exts = ['folder','folder-unempty','sql','c','cpp','cs','flv','css','js','htm','html','java','log','mht','php','url','xml','ai','bmp','cdr','gif','ico','jpeg','jpg','JPG','png','psd','webp','ape','avi','flv','mkv','mov','mp3','mp4','mpeg','mpg','rm','rmvb','swf','wav','webm','wma','wmv','rtf','docx','fdf','potm','pptx','txt','xlsb','xlsx','7z','cab','iso','bz2','rar','zip','gz','bt','file','apk','bookfolder','folder','folder-empty','folder-unempty','fromchromefolder','documentfolder','fromphonefolder','mix','musicfolder','picturefolder','videofolder','sefolder','access','mdb','accdb','sql','c','cpp','cs','js','fla','flv','htm','html','java','log','mht','php','url','xml','ai','bmp','cdr','gif','ico','jpeg','jpg','JPG','png','psd','webp','ape','avi','flv','mkv','mov','mp3','mp4','mpeg','mpg','rm','rmvb','swf','wav','webm','wma','wmv','doc','docm','dotx','dotm','dot','rtf','docx','pdf','fdf','ppt','pptm','pot','potm','pptx','txt','xls','csv','xlsm','xlsb','xlsx','7z','gz','cab','iso','rar','zip','bt','file','apk','css'];
	     var extLastName = extArr[extArr.length - 1];
	     for(var i=0; i<exts.length; i++)
         {if(exts[i]==extLastName)  return exts[i];}
        return 'file';
    }

   function DateToTime(unixTime,type="Y-M-D H:i:s")
   {
       var date=new Date(unixTime*1000);var datetime="";
       datetime+=date.getFullYear()+type.substring(1,2);datetime+=(date.getMonth()+1<10?"0"+(date.getMonth()+1):date.getMonth()+1)+type.substring(3,4);datetime+=(date.getDate()<10?"0"+(date.getDate()):date.getDate());if(type.substring(5,6)){if(type.substring(5,6).charCodeAt()>255){datetime+=type.substring(5,6);if(type.substring(7,8)){datetime+=" "+(date.getHours()<10?"0"+(date.getHours()):date.getHours());if(type.substring(9,10)){datetime+=type.substring(8,9)+(date.getMinutes()<10?"0"+(date.getMinutes()):date.getMinutes());if(type.substring(11,12)){datetime+=type.substring(10,11)+(date.getSeconds()<10?"0"+(date.getSeconds()):date.getSeconds())}}}}else{datetime+=" "+(date.getHours()<10?"0"+(date.getHours()):date.getHours());if(type.substring(8,9)){datetime+=type.substring(7,8)+(date.getMinutes()<10?"0"+(date.getMinutes()):date.getMinutes());if(type.substring(10,11)){datetime+=type.substring(9,10)+(date.getSeconds()<10?"0"+(date.getSeconds()):date.getSeconds())}}}};
       return datetime
   }